#pragma once
/*
 * Warren Hunt : 2006-10-09
 *
 */

#include "objectlist.h"



/*
 * Warren Hunt : 2006-10-09
 * Contains the list of object references (as unsinged __int32s)
 * Using indirection prevents excessive copying of memeory
 *
 */
class ReferenceArena {
	Array<unsigned __int32> data;
	unsigned __int32 top;
	unsigned __int32 cursor;

public:
	__forceinline ReferenceArena( const unsigned __int32 input_size )
		: data((unsigned __int32)(input_size))
	{
		for ( top = 0 ; top < input_size ; top++ )
			data[top] = top;
	}

	// accessor function
	__forceinline unsigned __int32 operator []( const unsigned __int32 index ) const { return data[index]; }

	// functions to aid kd-tree sifting
	__forceinline void append( const unsigned __int32 index ) { if ( top == data.size ) data.resize(2*data.size); data[top++] = data[index]; }
	__forceinline void seek( const unsigned __int32 index ) { cursor = index; }
	__forceinline void justify( const unsigned __int32 index ) { data[cursor++] = data[index]; }
	__forceinline void increment( void ) { cursor++; }
	__forceinline unsigned __int32 getPosition( void ) { return cursor; }
	__forceinline unsigned __int32 getTop( void ) { return top; }
};
