/*
 * Warren Hunt : 2006-10-09
 * The entry point for the library testing program (set up to test the kd-tree builder)
 *
 */



#include "stdafx.h"
#include "kdtree/kdtree.h"
#include <windows.h>

int main( int argc, char *argv[] )
{
	if ( argc != 2 && argc != 3  )
	{
		printf("requires arguments <filename> <quality> (1-9, default: 6)\n");
		exit(1);
	}
	ObjectList objectList(argv[1]);
	unsigned __int32 quality = 6;
	if ( argc == 3 )
		quality = atoi(argv[2]);
	if ( quality == 0 || quality > 9 )
	{
		printf("quality out of range!\n");
		exit(1);
	}

	LARGE_INTEGER rate; QueryPerformanceFrequency(&rate);
	LARGE_INTEGER sample0; QueryPerformanceCounter(&sample0);
	KDTree kdTree(objectList, KDTREEQUALITY[quality]);
	LARGE_INTEGER sample1; QueryPerformanceCounter(&sample1);
	float abstractCost = kdTree.cost();
	printf("%s\t%d\t%.2f\t%.0f\t%f\n", argv[1], quality, abstractCost, (double)objectList.size*rate.QuadPart/(sample1.QuadPart - sample0.QuadPart), (double)(sample1.QuadPart - sample0.QuadPart)/rate.QuadPart);
}
