#pragma once
/*
 * Warren Hunt : 1006-10-09
 * This file contains funtions to make __m128 do everything __m128i can (don't use __m128i)
 *
 */

#define reinterpret_cast(Type) *(Type *)&
#include <xmmintrin.h>
#include <emmintrin.h>


// casting and conversion routines
__forceinline __m128i convert( const __m128 input ) { return _mm_cvttps_epi32(input); }
__forceinline __m128 convert( const __m128i input ) { return _mm_cvtepi32_ps(input); }
__forceinline __m128i cast( const __m128 input ) { return reinterpret_cast(__m128i)(input); }
__forceinline __m128 cast( const __m128i input ) { return reinterpret_cast(__m128)(input); }

// replacement routines for __m128 instead of m128i
__forceinline __m128 _my_set1_epi32( const unsigned __int32 input ) { return cast(_mm_set1_epi32(input)); }
__forceinline __m128 _my_set_epi32( const unsigned __int32 input_0, const unsigned __int32 input_1, const unsigned __int32 input_2, const unsigned __int32 input_3 ) { return cast(_mm_set_epi32(input_0, input_1, input_2, input_3)); }

__forceinline __m128 _my_add_epi32( const __m128 input_0, const __m128 input_1 ) { return cast(_mm_add_epi32(cast(input_0), cast(input_1))); }
__forceinline __m128 _my_sub_epi32( const __m128 input_0, const __m128 input_1 ) { return cast(_mm_sub_epi32(cast(input_0), cast(input_1))); }
template <__int32 count> __forceinline __m128 _my_slli_epi32( const __m128 input ) { return cast(_mm_slli_epi32(cast(input), count)); }
template <__int32 count> __forceinline __m128 _my_srai_epi32( const __m128 input ) { return cast(_mm_srai_epi32(cast(input), count)); }
template <__int32 count> __forceinline __m128 _my_srli_epi32( const __m128 input ) { return cast(_mm_srli_epi32(cast(input), count)); }
template <__int32 count> __forceinline __m128 _my_slli_si128( const __m128 input ) { return cast(_mm_slli_si128(cast(input), count)); }
template <__int32 count> __forceinline __m128 _my_srli_si128( const __m128 input ) { return cast(_mm_srli_si128(cast(input), count)); }

__forceinline __m128 _my_cmpeq_epi32( const __m128 input_0, const __m128 input_1 ) { return cast(_mm_cmpeq_epi32(cast(input_0), cast(input_1))); }
__forceinline __m128 _my_cmplt_epi32( const __m128 input_0, const __m128 input_1 ) { return cast(_mm_cmplt_epi32(cast(input_0), cast(input_1))); }
__forceinline __m128 _my_cmpgt_epi32( const __m128 input_0, const __m128 input_1 ) { return cast(_mm_cmpgt_epi32(cast(input_0), cast(input_1))); }
