#pragma once
/*
 * Warren Hunt : 2006-10-09
 * Extra mathematical constructs
 *
 */

#include <math.h>



// determines if two numbers are very close (17/23) bits in the mantissa agree
__forceinline bool veryclose( const float input_0, const float input_1 ) { assume(input_0 != 0.0f || input_1 != 0.0f); return abs(input_0 - input_1)/(abs(input_0) + abs(input_1)) < 4e-4; }

// computes the log base two
__forceinline float log_2( const float input ) { const static float oneOverLn2 = 1.0f/log(2.0f); return log(input)*oneOverLn2; }
__forceinline double log_2( const double input ) { const static double oneOverLn2 = 1.0/log(2.0); return log(input)*oneOverLn2; }
__forceinline long double log_2( const long double input ) { const static long double oneOverLn2 = 1.0/log(2.0); return log(input)*oneOverLn2; }

